//
//  Chain.m
//  OME_BrowserXCoS
//
//  Created by Satoshi Takahashi on Sat Jan 25 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "Chain.h"
#import "MailTitles.h"
#import "Utils.h"
#import "Title.h"


@implementation Chain

- (NSMutableArray *) chainTitleArray:(const char *) curMailPath
{
NSMutableArray *array = [NSMutableArray arrayWithCapacity: 1];

    [mailTitles addTitleOf: curMailPath toArray: array];
    
    [self chainArray:array at:curMailPath header:"In-Reply-To:"
            extension:"midref" count: 100];
    [self chainArray:array at:curMailPath header:"Message-ID:"
            extension:"iftref" count: 100];
    return array;
}


- (void) chainArray:(NSMutableArray *)array at:(const char *)curMailPath
                header:(const char *)header extension:(const char *)extension
                count:(int) count
{
char mid[1024];
NSString *aliasFolderPathString, *aliasFilePathString;
BOOL found;
char replyToPath[1024];
NSFileManager *fm = [NSFileManager defaultManager];
NSDirectoryEnumerator *dirEnum;
//int i;
NSString *aliasFile;

    if (count <= 0)
        return;

    found = [self inReplyToMID: mid ofMail: curMailPath
                    header: header];
    if (!found)
        return;
    aliasFolderPathString = [NSString stringWithFormat:
                @"%s/temp/refByAliases/%s.%s",
                omeRootPath, mid, extension];
    dirEnum = [fm enumeratorAtPath: aliasFolderPathString];
    if (!dirEnum)
        return;
    while (aliasFile = [dirEnum nextObject])
    {
        aliasFilePathString = [aliasFolderPathString
                    stringByAppendingPathComponent: aliasFile];
        if (!aliasFilePathString)
            continue;
        SFResolveAliasPath([aliasFilePathString fileSystemRepresentation],
                replyToPath, 1024);
        [mailTitles addTitleOf:replyToPath toArray: array];
        [self chainArray:array at:replyToPath
                        header:header extension:extension count:count-1];
    }
}

- (BOOL) inReplyToMID:(char *)mid ofMail:(const char *)mailPath
            header:(const char *)headerKey
{
FILE *fp;
char oneLine[1024];
int headerKeyLength;
int oneLineLength;

    headerKeyLength = strlen(headerKey);
    fp = fopen(mailPath, "r");
    while(fgets(oneLine, 1024, fp))
    {
        if (HeadStrCL(headerKey, oneLine))
        {
            oneLineLength = strlen(oneLine);
            if (oneLine[oneLineLength-1] == '\n')
                oneLine[oneLineLength-1] = 0;
            strcpy(mid, oneLine + headerKeyLength + 1);
            fclose(fp);
            return YES;
        }
    }
    fclose(fp);
    return NO;
}


- (IBAction) chainTitle:(NSMenu *)sender
{
int index;
NSString *pathString;

    [mailTitleWindow setTitle: Localize(@"Related Mails")];

    index = [table selectedRow];
    pathString = [(Title *)[[mailTitles mailTitles] objectAtIndex: index]
                    pathString];
    [mailTitles setMailTitles: [self chainTitleArray:
            [pathString fileSystemRepresentation]]];
    [mailTitles sortTitle];
}

@end
