//
//  Coding.h
//  OME_BrowserXCoS
//
//  Created by Satoshi Takahashi on Sat Jul 27 2002.
//  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface Coding : NSObject {
    NSMutableDictionary *charsetCodeDict;
    NSMutableDictionary *omeCharsetCodeDict;
    unsigned int defaultCode;
    NSDictionary *codeNameDict;
    NSDictionary *fileCodeDict;
    NSMutableDictionary *fontDict;
    NSArray *codeArray;
    NSDictionary *langNameDict;
    NSDictionary *prefNameDict;
    IBOutlet NSTableView *fontTable;
    unsigned int lastRow;
    unsigned int multipartFileCoding;
    unsigned int sendFileCoding;
}

- init;

- (NSDictionary *) initEncodeNameDict;
- (NSDictionary *) initFileCodeDict;
- (NSDictionary *) initLangNameDict;
- (NSDictionary *) initPrefNameDict;
NSNumber *NSEncode(unsigned int nsEncode);
NSNumber *CFEncode(CFStringEncoding cfEncode);
- (void) initFontDict;
- (void) initFileCoding;
- (void) loadEncodeFontDictionaryOfNumber: (int) number;
- (void) terminate: (NSNotification *) notification;

- (void) setDefaultCode: (unsigned int)newDefaultFilecoding;
- (void) setMultipartFileCoding: (unsigned int)newMultipartFilecoding;
- (void) setSendFileCoding: (unsigned int)newSendFilecoding;
- (NSDictionary *) charsetCodeDict;
- (unsigned int) defaultCode;
//- (unsigned int) defaultFileCoding;
//- (unsigned int) fileCodeForCode: (unsigned int) myCode;
- (unsigned int) multipartFileCoding;
- (unsigned int) sendFileCoding;
- (unsigned int) codeFromCharset: (char *) charset isOMECharset: (BOOL) isOME;
- (unsigned int) fileCodeFromCode: (unsigned int) code;
//- (unsigned int) fileCodingFromCharset: (char *) charset;
- (NSFont *) fontFromEncode: (unsigned int) encode;
NSComparisonResult compareCode(NSNumber *code1, NSNumber *code2, void *dict);
- (IBAction) selectFont: (NSTableView *) fontTable;
- (void) setLastRow: (unsigned int) newLastRow;
- (unsigned int) lastRow;
@end
