//
//  MailDate.m
//  table
//
//  Created by takahasi on Sun Sep 16 2001.
//  Copyright (c) 2001 __CompanyName__. All rights reserved.
//

#import "MailDate.h"
/*#import "MailTitles.h"*/
#import "Utils.h"


NSCalendarDate *CString2Date(const char *string)
{
MailDateRec md;

	if (ParseDateString(string, &md))
		return 0;
//printf("%d.%u.%u / %u:%u:%u   %d\n", md.year, md.month, md.day, md.hour, md.minute,
			//md.second, md.timeZone/3600);
	return [[NSCalendarDate alloc] initWithYear:md.year month:md.month day:md.day
		hour:md.hour minute:md.minute second:md.second
		timeZone:[NSTimeZone timeZoneForSecondsFromGMT:md.timeZone]];
}


typedef struct timeZoneData
{
	char *tzName;
	int tzTime;
} TimeZoneData;


int ParseDateString(const char *string, MailDateRec *md)
{
char *monthString[] = {"DMY", "Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
int i;
TimeZoneData tzAbb[] = { {"JST", 9}, {"UT", 0}, {"GMT", 0},
	{"EST", -5}, {"EDT", -4}, {"CST", -6}, {"CDT", -5},
	{"MST", -7}, {"MDT", -6}, {"PST", -8}, {"PDT", -7},
	{0, 0}};
TimeZoneData tzUSArmy[] = {{"Z", 0}, {"A", -1}, {"B", -2}, {"C", -3},
	{"D", -4}, {"E", -5}, {"F", -6}, {"G", -7}, {"H", -8}, {"I", -9},
	{"K", -10}, {"L", -11}, {"M", -12},
	{"N", 1}, {"O", 2}, {"P", 3}, {"Q", 4}, {"R", 5}, {"S", 6}, {"T", 7},
	{"U", 8}, {"V", 9}, {"W", 10}, {"X", 11}, {"Y", 12}, {0, 0}};


//printf("string = %s\n", string);

	while (string[0] && !isdigit(string[0]))
		string++;
	if (!(md->day = atoi(string)))
		return -1;
//printf("day = %u\n", md->day);
	
	while (string[0] && !isalpha(string[0]))
		string++;
	for (i = 1; i <= 12; i++)
	{
		if (HeadStrCL(monthString[i], string))
		{
			md->month = i;
			break;
		}
	}
	if (!md->month)
		return -1;
	
	while (string[0] && !isdigit(string[0]))
		string++;
	if (!string[0])
		return -1;
	md->year = atoi(string); /*00 is possible*/
	if (md->year < 90)
		md->year += 2000;
	else if (md->year < 100)
		md->year += 1900;

//printf("yearstring=%s\n", string);
	while (string[0] && isdigit(string[0]))
		string++;
	while (string[0] && !isdigit(string[0]))
		string++;
	if (!string[0])
		return -1;
//printf("hourstring=%s\n", string);
	md->hour = atoi(string);
	
	while (string[0] && isdigit(string[0]))
		string++;
	while (string[0] && !isdigit(string[0]))
		string++;
	if (!string[0])
		return -1;
	md->minute = atoi(string);
	
	while (string[0] && isdigit(string[0]))
		string++;
	if (string[0] == ':')
	{
		string++;
		if (!string[0])
			return -1;
		md->second = atoi(string);
		while (string[0] && isdigit(string[0]))
			string++;
	}
	else
		md->second = 0;
	
	while(isspace(string[0]))
		string++;

//printf("tzstring=%s\n", string);
	
	md->timeZone = 9*3600;
	
	if ((string[0] == '+') || (string[0] == '-'))
	{
		md->timeZone = (((string[1]-'0')*10 + (string[2]-'0'))*60
						+ ((string[3]-'0')*10 + (string[4]-'0')))*60;
		if (string[0] == '-')
		md->timeZone *= -1;
	}
	else if (strlen(string) == 1) /*USArmy Format ?*/
	{
		for (i = 0; tzUSArmy[i].tzName; i++)
		{
			if (!strcmp(string, tzUSArmy[i].tzName))
			{
				md->timeZone = tzUSArmy[i].tzTime*3600;
				break;
			}
		}
	}
	else
	{
		for (i = 0; tzAbb[i].tzName; i++)
		{
			if (!strcmp(string, tzAbb[i].tzName))
			{
				md->timeZone = tzAbb[i].tzTime*3600;
				break;
			}
		}
	}
	
	return 0;
}