#import "MenuController.h"
#import "Utils.h"
#import "Title.h"
#import "MailContents.h"
#import "MailTitles.h"
#import "AppController.h"
#import "FSNodeInfo.h"
#import "BrowserTextView.h"

@implementation MenuController

NSString *tagName[] = {@"name", @"modDate"};
NSTimeInterval interval = 2.0; /*to match type*/

- (void) dealloc
{
	[moveArray release];
	[super dealloc];
}


- (void) awakeFromNib
{
int count;
int i;

	[[NSNotificationCenter defaultCenter] addObserver: self
		selector: @selector(saveMoveArray:)
		name: NSApplicationWillTerminateNotification object:nil];
	[[NSNotificationCenter defaultCenter] addObserver: self
		selector: @selector(allFront:)
		name: NSApplicationDidBecomeActiveNotification object:nil];

	if (SetOMESettingPath())
		return;

	moveArray = [[[NSUserDefaults standardUserDefaults]
				arrayForKey: @"Move Folder"] mutableCopy];
	if (moveArray)
		[moveArray retain];
	else
		moveArray = [[NSMutableArray alloc] initWithCapacity: 1];
	
	count = [moveArray count];
	for (i = 0; i < count; i++)
	{
		[self addFolderPathString: (NSString *)[moveArray objectAtIndex: i] atIndex: i];
	}
}

- (IBAction)reply:(NSMenuItem *)sender
{
NSString *pathString;
NSString *newPathString;
int index;
Title *title;
NSEnumerator *enumerator = [table selectedRowEnumerator];
NSNumber *currentNumber;

    while(currentNumber = (NSNumber *)[enumerator nextObject])
    {
        index = [currentNumber intValue];
        //index = [table selectedRow];
        if (index <0 )
            continue;
		title = (Title *)[[mailTitles mailTitles] objectAtIndex: index];

        pathString = [title pathString];
        //pathString = [mailContents currentPathString];
        
        if (![title replyState])
        {
            [title setReplyState: 1];
            newPathString = [[pathString stringByDeletingPathExtension]
                                stringByAppendingPathExtension: @"rply"];
            [[NSFileManager defaultManager] movePath: pathString
                    toPath: newPathString handler: nil];
            pathString = [NSString stringWithString: newPathString];
            [title setPathString: pathString];
            //SFCoSetTypeCreator([pathString fileSystemRepresentation],
                                    //'MAIL', 'ome1');
            [table reloadData];
            [mailContents setCurrentPathString: pathString];
        }
        
        if (pathString)
        {
            [[NSWorkspace sharedWorkspace] openFile: pathString
                withApplication: @"/Applications/OME_Applications/OME_MailWriter.app"];
            system("sleep 5");
        }
    }
}


- (IBAction)newMail:(NSMenuItem *)sender
{
	[[NSWorkspace sharedWorkspace] 
		launchApplication: @"/Applications/OME_Applications/OME_MailWriter.app"];
}


- (IBAction)openByMailReader:(NSMenuItem *)sender
{
NSString *pathString;
NSString *mailReaderAliasPath = [NSString stringWithFormat: @"%s/Mail_Reader", omeSettingPath];
char mailReaderCPath[1024];
NSEnumerator *enumerator = [table selectedRowEnumerator];
NSNumber *currentNumber;
int index;
OSErr error;

	error = SFResolveAliasPath([mailReaderAliasPath fileSystemRepresentation],
								mailReaderCPath, 1024);
	
    while(currentNumber = (NSNumber *)[enumerator nextObject])
    {
        index = [currentNumber intValue];
        if (index <0 )
            continue;

        pathString = [(Title *)[[mailTitles mailTitles] objectAtIndex: index] pathString];
        
        if (pathString)
        {
			[[NSWorkspace sharedWorkspace] openFile: pathString
                withApplication: Path2String(mailReaderCPath)];
            system("sleep 5"); /* in case Mail_Reader launches */
        }
    }
}


- (IBAction)deleteMail:(NSMenuItem *)sender
{
	[NSApp runModalForWindow: confirmWindow];
}


- (IBAction)deleteMailYes:(NSButton *)sender
{
NSString *pathString;
NSEnumerator *enumerator = [[[table selectedRowEnumerator]
        allObjects] objectEnumerator];
    /* prevent enumerator change on removeIndex */
NSNumber *currentNumber;
int index;
int removed = 0;
Title *currentTitle;

    while(currentNumber = (NSNumber *)[enumerator nextObject])
    {
        index = [currentNumber intValue];
        index -= removed;
        if (index <0 )
            continue;

        currentTitle = (Title *)[[mailTitles mailTitles] objectAtIndex: index];
        pathString = [currentTitle pathString];
        if (pathString)
        {
            if ([currentTitle archiveState])
                pathString = [pathString stringByDeletingLastPathComponent];
            [[NSFileManager defaultManager] removeFileAtPath: pathString
                    handler: nil];
            [mailTitles removeAtIndex: index];
            removed++;
        }
    }
	[NSApp stopModal];
	[confirmWindow close];
}


- (IBAction)deleteMailNo: (NSButton *) sender
{
	[NSApp stopModal];
	[confirmWindow close];
}


- (IBAction)addCurrentFolder: (NSMenuItem *) sender
{
	[self addFolder: [fsBrowser path]];
}

- (void)addFolder: (NSString *) folderPathString
{
	if ([folderPathString hasPrefix: omeRootPathString])
		folderPathString = [folderPathString substringFromIndex: [omeRootPathString length]+1];
	[moveArray addObject: folderPathString];
	[self addFolderPathString: folderPathString atIndex: [moveArray count]-1];
}

- (void)addFolderPathString: (NSString *) folderPathString atIndex: (int) index
{
NSMenuItem *moveMenuItem;

	moveMenuItem = (NSMenuItem*)[moveMenu insertItemWithTitle:
					[folderPathString lastPathComponent]
			action: @selector(moveMailTo:) keyEquivalent: @""
			atIndex: index];
	if (index < 9)
		[moveMenuItem setKeyEquivalent: [NSString stringWithFormat:@"%d", index+1]];
	[moveMenuItem setTarget: self];
	[moveMenuItem setTag: index];
}


- (void) moveMailTo: (NSMenuItem *) sender
{
NSString *newDirectory = [moveArray objectAtIndex: [sender tag]];

	if (![newDirectory hasPrefix: @"/"])
		newDirectory = [omeRootPathString stringByAppendingPathComponent: newDirectory];
	[self moveMailToDirectory: newDirectory];
}


- (void) moveMailToDirectory: (NSString *) newDirPathString
{
NSEnumerator *enumerator = [[[table selectedRowEnumerator]
        allObjects] objectEnumerator];
    /* prevent enumerator change on removeIndex */
int currentIndex;
Title *currentTitle;
NSString *currentPathString;
int removed = 0;
NSNumber *currentNumber;
        
    while(currentNumber = (NSNumber *)[enumerator nextObject])
    {
        currentIndex = [currentNumber intValue];
        currentIndex -= removed;
        currentTitle = (Title *)[[mailTitles mailTitles] objectAtIndex:
                            currentIndex];
        currentPathString = [currentTitle pathString];
        if ([currentTitle archiveState])
            currentPathString = [currentPathString
                                    stringByDeletingLastPathComponent];
        [[NSFileManager defaultManager] movePath: currentPathString
                toPath: [newDirPathString stringByAppendingPathComponent: 
                    [currentPathString lastPathComponent]]
                handler: nil];
        [mailTitles removeAtIndex: currentIndex];
        removed++;
    }
    [mailTitles showInTitleIndex: currentIndex];
}


- (IBAction)remove: (NSMenuItem *) sender
{
	[moveTable noteNumberOfRowsChanged];
	[NSApp runModalForWindow: removeWindow];
}


- (IBAction)removeCancel: (NSButton *) sender
{
	[NSApp stopModal];
	[removeWindow close];
}


- (int) numberOfRowsInTableView: (NSTableView *)tableView
{
	return [moveArray count];
}


- (id) tableView: (NSTableView *)tableView
		objectValueForTableColumn: (NSTableColumn *)tableColumn
		row: (int)row
{
	return [[moveArray objectAtIndex: row] lastPathComponent];
}


- (IBAction)removeItem: (NSTableView *) sender
{
int index = [sender selectedRow];
int i;
int count;

	[moveArray removeObjectAtIndex: index];
	[moveMenu removeItemAtIndex: index];
	
	count = [moveArray count];
	for (i = index; i < count; i++)
	{
		[[moveMenu itemAtIndex: i] setTag: i];
		if (i < 9)
			[[moveMenu itemAtIndex: i] setKeyEquivalent:
					[NSString stringWithFormat: @"%d", i+1]];
	}
	
	[NSApp stopModal];
	[removeWindow close];
}

- (IBAction)removeAll: (NSTableView *) sender
{
int i;
int count = [moveArray count];

	[moveArray removeAllObjects];
	for (i = 0; i < count; i++)
		[moveMenu removeItemAtIndex: 0];
	
	[NSApp stopModal];
	[removeWindow close];
}


- (void) saveMoveArray: (NSNotification *) notification
{
	[[NSUserDefaults standardUserDefaults]
		setObject: moveArray forKey: @"Move Folder"];
}


- (IBAction) refreshList: (NSMenuItem *) sender
{
	[mailTitles loadTitleTable: (char *)[[fsBrowser path]
			fileSystemRepresentation] refresh: (sender != nil)];
    if ([[FSNodeInfo sortFolderTag] isEqualToString: @"modDate"])
        [fsBrowser reloadColumn: [fsBrowser lastVisibleColumn]];    
}


- (IBAction) browseInBox: (NSMenuItem *) sender
{
	[appController browseInBox];
}


- (IBAction) readNextMail: (NSMenuItem *) sender
{
	[mailTitles readNextMail];
}

- (IBAction) download: (id) sender
{
#if 0
	[[NSWorkspace sharedWorkspace] 
		launchApplication:
		@"/Applications/OME_Applications/OME_DownloadMails.app"];
#else
    system("nice java -cp /Applications/OME_Applications/tools/OME_lib.jar:/System/Library/Java/ "
                "OME.downloadmails.OME_DownloadMails &");
#endif
	[NSTimer scheduledTimerWithTimeInterval: interval target: self
		selector: @selector(checkDownloading:) userInfo: nil
		repeats: YES];
	[titleWindow setTitle: Localize(@"Downloading...")];
}

- (void) checkDownloading: (NSTimer *) timer
{
	if (!system("ps xw | grep DownloadMails | grep -v grep > /dev/null"))
		return;
	if (!system("ps xw | grep OME_MailProcessor | grep -v grep > /dev/null"))
        return;
	if (!system("ps xw | grep java | grep OME | grep -v grep > /dev/null"))
		return;
	
	[timer invalidate];
	[titleWindow setTitle: [[fsBrowser path] lastPathComponent]];
	//[NSTimer scheduledTimerWithTimeInterval: 3.0 target: self
		//selector: @selector(refreshList:) userInfo: nil
		//repeats: NO];
	[self refreshList: nil];
}



- (void) allFront: (NSNotification *) notification
{
	[folderWindow orderFront: self];
	[titleWindow orderFront: self];
	[contentsWindow makeKeyAndOrderFront: self];
}


- (IBAction) sortFolderByMenu: (NSMenuItem *) sender
{
    [self sortFolderByTag: tagName[[sender tag]]];

	[fsBrowser reloadColumn: [fsBrowser lastVisibleColumn]];    
}


- (void) sortFolderByTag: (NSString *) tag
{
    [FSNodeInfo setSortFolderTag: tag];
    
    [sortFolderByName setState: NSOffState];
    [sortFolderByModDate setState: NSOffState];
    
    if ([tag isEqualToString: @"name"])
        [sortFolderByName setState: NSOnState];
    else if ([tag isEqualToString: @"modDate"])
        [sortFolderByModDate setState: NSOnState];
}

#if 0
- (BOOL) applicationOpenUntitledFile: (NSApplication *) theApp
{
	if ((system("ps xw | grep MessageMaker | grep -v grep > /dev/null"))
            && (system("ps xw | grep DownloadMails | grep -v grep > /dev/null")))
        [self refreshList: nil];
    else
    {
        [NSTimer scheduledTimerWithTimeInterval: interval target: self
            selector: @selector(checkDownloading:) userInfo: nil
            repeats: YES];
        [titleWindow setTitle: Localize(@"Downloading...")];
    }
    return YES;
}
#endif


- (IBAction) launchURL: (NSMenuItem *) sender
{
NSString *pathString;
NSEnumerator *enumerator = [table selectedRowEnumerator];
NSNumber *currentNumber;
int index;

    while(currentNumber = (NSNumber *)[enumerator nextObject])
    {
        index = [currentNumber intValue];
        if (index <0 )
            continue;

        pathString = [(Title *)[[mailTitles mailTitles] objectAtIndex: index] pathString];
 
        if (!pathString)
            continue;
            
        [[NSWorkspace sharedWorkspace] openFile: pathString];
        system("sleep 5"); /*necessary?*/
    }
}


- (IBAction)addressBook: (NSMenuItem *) sender
{
NSString *addressBookPath;
OSErr error = 1;
char addressBookResolvedPath[1024];

    addressBookPath = [[NSString stringWithCString: omeSettingPath]
            stringByAppendingPathComponent: @"Address_Book"];
    if ([[NSFileManager defaultManager] fileExistsAtPath: addressBookPath])
    {
        error = SFResolveAliasPath([addressBookPath fileSystemRepresentation],
                        addressBookResolvedPath, 1024);
    }
    if (!error)
        addressBookPath = [NSString stringWithCString:
                                addressBookResolvedPath];
    else
        addressBookPath = @"/Applications/Address Book.app";
        
	[[NSWorkspace sharedWorkspace] 
		launchApplication: addressBookPath];
}


- (IBAction) showMail: (NSMenuItem *) sender
{
NSString *pathString;
NSEnumerator *enumerator = [table selectedRowEnumerator];
NSNumber *currentNumber;
int index;

    while(currentNumber = (NSNumber *)[enumerator nextObject])
    {
        index = [currentNumber intValue];
        if (index <0 )
            continue;

        pathString = [(Title *)[[mailTitles mailTitles] objectAtIndex: index] pathString];
        [[NSWorkspace sharedWorkspace] selectFile: pathString
                inFileViewerRootedAtPath:@""];
    }
}


- (IBAction) search: (NSMenuItem *) sender
{
	[[NSWorkspace sharedWorkspace] 
		launchApplication: @"/Applications/OME_Applications/OME_search.app"];
}


- (IBAction) printSelection: (NSMenuItem *)sender
{
//NSString *s;

    [hiddenText setString: [[[mailContents browserTextView] string]
            substringWithRange: [[mailContents browserTextView] selectedRange]]];
    [hiddenText print: self];
}


- (IBAction) OMEMove: (NSMenuItem *) sender
{
	[[NSWorkspace sharedWorkspace] 
		launchApplication: @"/Applications/OME_Applications/OME_Move.app"];
}


- (IBAction) addFolderAndMove: (NSMenuItem *) sender
{
NSSavePanel *savePanel = [NSSavePanel savePanel];
int ret;
#if 0 /* Doesn't work in Tiger */
NSView *content, *sub;
static int first = 1;

	content = [savePanel contentView];
	if (first)
	{
		first = 0;
		sub = [[[[[[content subviews] objectAtIndex: 1]
						 subviews] objectAtIndex: 0]
						 subviews] objectAtIndex: 1];
		[(NSControl *)sub setEnabled: 0];
	}
#endif
    //[savePanel setExtensionHidden: 0];
    [savePanel setPrompt: Localize(@"Choose")];

	ret = [savePanel runModalForDirectory: omeRootPathString
                file: @"-----------------"];

    if (ret != NSFileHandlingPanelOKButton)
        return;

    [self addFolder: [savePanel directory]];
    [self moveMailToDirectory: [savePanel directory]];
}

- (IBAction) makeRead: (NSMenuItem *) sender
{
NSEnumerator *enumerator = [table selectedRowEnumerator];
NSNumber *currentNumber;
int index;
Title *title;

    while(currentNumber = (NSNumber *)[enumerator nextObject])
    {
        index = [currentNumber intValue];
        if (index <0 )
            continue;
		title = (Title *)[[mailTitles mailTitles] objectAtIndex: index];
		[title makeRead];
	}

	[table reloadData];
	
	unreadUtilTimer = [NSTimer scheduledTimerWithTimeInterval: 1.0
			target: mailContents selector: @selector(launchUnread:)
			userInfo: nil repeats: NO];
}

@end